
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Local Functions / 憋错料</title>

    <meta name="description" content="Local Functions int BOOST_LOCAL_FUNCTION(int x, int y) { // Local function. return x + y; } BOOST_LOCAL_FUNCTION_NAME(add) BOOST_TEST(add(1, 2) == 3); // Local function call. int BOOST_LOCAL_FUNCTION(void) { // No parameter. return 10; } BOOST_LOCAL_FUNCTION_NAME(te">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Local Functions</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<pre>int BOOST_LOCAL_FUNCTION(int x, int y) { // Local function.
    return x + y;
} BOOST_LOCAL_FUNCTION_NAME(add)

BOOST_TEST(add(1, 2) == 3); // Local function call.</pre>
<p><pre>int BOOST_LOCAL_FUNCTION(void) { // No parameter.
    return 10;
} BOOST_LOCAL_FUNCTION_NAME(ten)

BOOST_TEST(ten() == 10);</pre>
<pre>This library introduces the new &quot;keyword&quot; bind [9] which is used in place of the parameter type to specify the name of a variable in scope to bind (therefore, bind cannot be used as a local function parameter type). A variable can be bound by value:

bind variable-name // Bind by value.
Or by reference prefixing the variable name with &amp;:

bind&amp; variable-name // Bind by reference.
Furthermore, the &quot;keyword&quot; bind can be prefixed by const to bind the variable by constant value:

const bind variable-name // Bind by constant value.
Or by constant reference:

const bind&amp; variable-name // Bind by constant value.</pre>
<pre>int main(void) {                            // Some local scope.
    int sum = 0, factor = 10;               // Variables in scope to bind.

    void BOOST_LOCAL_FUNCTION(const bind factor, bind&amp; sum, int num) {
        sum += factor * num;
    } BOOST_LOCAL_FUNCTION_NAME(add)

    add(1);                                 // Call the local function.
    int nums[] = {2, 3};
    std::for_each(nums, nums + 2, add);     // Pass it to an algorithm.

    BOOST_TEST(sum == 60);                  // Assert final summation value.
    return boost::report_errors();
}</pre>
<h3>Binding<br />
 the Object&nbsp;<code>this</code></h3>
<p>It is also possible to bind the object&nbsp;<code>this</code>&nbsp;when it is in scope (e.g., from an enclosing non-static<br />
 member function). This is done by using the special symbol&nbsp;<code>this_</code>&nbsp;(instead of&nbsp;<code>this</code>) as the name of the variable to bind in the local<br />
 function declaration and also to access the object within the local function body.&nbsp;[13]</p>
<table>
<tbody>
<tr>
<td rowspan="2"><img src="/boost_1_55_0/doc/src/images/warning.png"></td>
<th>Warning</th>
</tr>
<tr>
<td>
<br />The library will generate a compile-time error if&nbsp;<code>this</code>&nbsp;is mistakenly used instead of&nbsp;<code>this_</code>&nbsp;to<br />
 bind the object in the local function declaration. However, mistakenly using&nbsp;<code>this</code>instead of&nbsp;<code>this_</code>&nbsp;to access the object within the<br />
 local function body will leads to undefined behaviour and it will not necessarily generate a compile-time error.&nbsp;[14]Programmers<br />
 are ultimately responsible to make sure that&nbsp;<code>this</code>&nbsp;is never used within a local function.</p>
</td>
</tr>
</tbody>
</table>
<p>The object&nbsp;<code>this</code>&nbsp;can be bound by value:</p>
<pre>bind this_ // Bind the object `this` by value.
</pre>
<p>In this case the local function will be able to modify the object when the enclosing scope is not a constant member and it will not be able to modify the object when the enclosing scope is<br />
 a constant member. Otherwise, the object&nbsp;<code>this</code>&nbsp;can be bound by constant value:</p>
<pre>const bind this_ // Bind the object `this` by constant value.</pre>
<p><pre>struct adder {
    adder() : sum_(0) {}

    int sum(const std::vector&lt;int&gt;&amp; nums, const int factor = 10) {

        void BOOST_LOCAL_FUNCTION(const bind factor, bind this_, int num) {
            this_-&gt;sum_ += factor * num; // Use `this_` instead of `this`.
        } BOOST_LOCAL_FUNCTION_NAME(add)

        std::for_each(nums.begin(), nums.end(), add);
        return sum_;
    }

private:
    int sum_;
};</pre>
<p><P><A href="http://www.bubuko.com/infodetail-162587.html" rel="external nofollow noreferrer">Local Functions,布布扣,bubuko.com</A></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-11 21:35:42 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/boost/" title="boost">boost</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Local Functions的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/n4ABrzM.html" rel="bookmark">码农交流日常&mdash;&mdash;我只能说&colon;MDZZ（手动微笑）</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				本文属吐槽文,我只想说:对神论还蜜汁自信的怎么破? ------------------------------背景介绍--------------------------------------- 上半年参与了一个水的不行的项目,总的架构如下: 用C++作为实现语言 在Windows下,用户界面以EXE的形式出现,其他模块以DLL的形式通过LoadLibrary加载 数据总控模块提供一套API给&quot;自定义功能模块&quot;使用,实现用户界面和功能模块的交互,自然,所有的自定义功能模块也都按照约			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/N4p7OV3.html" rel="bookmark">在LINUX中跟踪函数调用----http&colon;&sol;&sol;stackoverflow&period;com&sol;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				http://stackoverflow.com/questions/311840/tool-to-trace-local-function-calls-in-linux I am looking for a tool like ltrace or strace that can trace locally defined functions in an executable. ltrace only traces dynamic library calls and strace only tr			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MPNZBm3.html" rel="bookmark">AACOS：基于编译器和操作系统内核的算法设计与实现</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				AACOS:基于编译器和操作系统内核的算法设计与实现 [计算机科学技术] 谢晓啸 湖北省沙市中学 [关键词]: 编译原理,操作系统内核实现,算法与数据结构,算法优化 0．索引 1.引论 1.1研究内容 1.2研究目的 1.3研究提要 正文 2.1研究方法 2.2编译器部分 2.2.1从计算器程序中得到的编译器制作启示 2.2.2在编译器中其它具体代码的实现 2.2.3编译器中栈的高级应用 2.2.3编译器中树的高级应用 2.2.4编译器与有限状态机 2.3操作系统内核部分 2.3.1操作系统与底			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/My5mvVM.html" rel="bookmark">ZigBee学习四 无线&plus;UART通信</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ZigBee学习四 无线+UART通信 1) 协调器编程 修改coordinator.c文件 byte GenericApp_TransID; // This is the unique message ID (counter) afAddrType_t GenericApp_DstAddr; //unsigned char uartbuf[128];/********************************************************************** L			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3ZYNPg0.html" rel="bookmark">ZigBee学习三 UART通信</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				ZigBee学习三 UART通信 本实验只对coordinator.c文件进行改动就可以实现串口的收发. 修改coordinator.c文件 byte GenericApp_TransID; // This is the unique message ID (counter) afAddrType_t GenericApp_DstAddr; unsigned char uartbuf[128];/**************************************************			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MP8LLaM.html" rel="bookmark">Matlab编程基础</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				平台:Win7 64 bit,Matlab R2014a(8.3) &quot;Matlab&quot;是&quot;Matrix Laboratory&quot; 的缩写,中文&quot;矩阵实验室&quot;,是强大的数学工具.本文侧重于Matlab的编程语言侧面,讲述Matlab的基本语法,以及用Matlab语言进行程序设计.值得一提的是,Matlab从R2014a版本开始支持中文语言了! 1.基本概念 Matlab默认启动后界面: Matlab有关的文件后缀: File Extension Des			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/3vKkOR4.html" rel="bookmark">&lbrack;干货来袭&rsqb;C&num;7&period;0新特性&lpar;VS2017可用&rpar;&lpar;转&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				出处:http://www.cnblogs.com/GuZhenYin/p/6526041.html 微软昨天发布了新的VS 2017 ..随之而来的还有很多很多东西... .NET新版本 ASP.NET新版本...等等..太多..实在没消化.. 分享一下其实2016年12月就已经公布了的C#7.0的新特性吧,虽然很早就出来了,但咱这IDE不支持啊.. 不过在昨天的VS2017中已经完美可以支持使用了. E文好的,移步官方介绍地址:https://docs.microsoft.com/zh-cn			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzQ6bO4.html" rel="bookmark">board&lowbar;key&period;h&sol;board&lowbar;key&period;c</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				1 /******************************************************************************* 2 Filename: board_key.h 3 Revised: $Date: 2014-02-28 14:18:14 -0800 (Fri, 28 Feb 2014) $ 4 Revision: $Revision: 37461 $ 5 6 Description: This file contains the SRF06EB			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0bO9Ov3.html" rel="bookmark">&lbrack;干货来袭&rsqb;C&num;7&period;0新特性&lpar;VS2017可用&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				原文:http://www.cnblogs.com/GuZhenYin/p/6526041.html 前言 微软昨天发布了新的VS 2017 ..随之而来的还有很多很多东西... .NET新版本 ASP.NET新版本...等等..太多..实在没消化.. 分享一下其实2016年12月就已经公布了的C#7.0的新特性吧,虽然很早就出来了,但咱这IDE不支持啊.. 不过在昨天的VS2017中已经完美可以支持使用了. E文好的,移步官方介绍地址:https://docs.microsoft.com/zh			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MVw8wj0.html" rel="bookmark" class="title">和小伙伴的结伴编程</a>
					<div>
						和徐鹏小伙伴的结对编程 由于我能力比较弱我就写了一个小软件简单的登陆 :) package com.example.chen; import android.app.Activity; import  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0x8gvQ0.html" rel="bookmark" class="title">Windows XP Embedded中与用户账户相关的组件</a>
					<div>
						Administrator Account :管理员用户,可以设置管理员的密码: User Account:除了管理员之外,可以再建立系统的第二个用户: Users Control Panel:用户和 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0en72D3.html" rel="bookmark" class="title">git - a stupied content tracker</a>
					<div>
						introduction     git is a fast,scalable and distributed version control system with an unusually ric ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0bY69YM.html" rel="bookmark" class="title">POJ2456 Aggressive cows&lpar;二分&plus;贪心&rpar;</a>
					<div>
						假设C(d)为满足所有牛之间的距离都不小于d.先对牛舍的位置排序,然后二分枚举d,寻找满足条件的d. #include&lt;iostream&gt; #include&lt;cstdio&gt; # ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rEqWg0.html" rel="bookmark" class="title">nyoj 739 笨蛋的难题四</a>
					<div>
						笨蛋难题四 时间限制:1000 ms  |  内存限制:65535 KB 难度:3 描述 这些日子笨蛋一直研究股票,经过调研,终于发现xxx公司股票规律,更可喜的是 笨蛋推算出这家公司每天的股价,为了 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MomrPl3.html" rel="bookmark" class="title">mongodb版本管理</a>
					<div>
						使用gradle. 查找最新版本http://mvnrepository.org/ compile &quot;org.mongeez:mongeez:0.9.6&quot; 配置spring &lt ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wy29VM.html" rel="bookmark" class="title">Linux下命令行安装配置android sdk</a>
					<div>
						首先, 你得有个VPN 参考以下三篇完成Android SDK的安装 https://www.digitalocean.com/community/tutorials/how-to-build-and ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/Mz16ql4.html" rel="bookmark" class="title">bzoj4275 &lbrack;ONTAK2015&rsqb;Badania naukowe</a>
					<div>
						传送门:http://www.lydsy.com/JudgeOnline/problem.php?id=4275 [题解] 考虑预处理出来a[1..i]和b[1..j]的LCS,记为$f_{i,j}$ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyldNA4.html" rel="bookmark" class="title">LINUX REDHAT第十单元文档</a>
					<div>
						1.系统日志默认分类#### /var/log/messages##系统服务及日志,包括服务的信息,报错等等 /var/log/secure##系统认证信息日志 /var/log/maillog##系 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/41oRVG0.html" rel="bookmark" class="title">bash脚本编程的语法知识点总结第一部分</a>
					<div>
						bash脚本编程的所有语法知识点总结第一部分 名词概念 bash脚本编程,从字面意思理解也就是shell脚本编程.bash应该是目前Linux上最流行的shell脚本解释程序.shell是一个命令语言 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nP2mV4.html" rel="bookmark" class="title">pyhton 查询当前路径和子路径后缀名相同的文件</a>
					<div>
						# -*- encoding:utf-8 -*-import osdef SearchFile(path,text): try: files=os.listdir(path) for f in fil ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzEnGA4.html" rel="bookmark" class="title">&lbrack;翻译&rsqb; IDMPhotoBrowser</a>
					<div>
						IDMPhotoBrowser IDMPhotoBrowser is a new implementation based on MWPhotoBrowser. IDMPhotoBrowser实现了图 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPvYeP3.html" rel="bookmark" class="title">【Python运维脚本】Python监控网卡流量</a>
					<div>
						#!/usr/bin/env python # -*- coding=utf-8 -*- #Using GPL v2.7 #Author: [email protected]126.com #Pyth ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kvLD0.html" rel="bookmark" class="title">红帽官方RHEL 7&period;2内核更新说明3&period;10&period;0-327&period;22&period;2</a>
					<div>
						红帽官方发布的内核安全和bug修复更新说明如下: https://rhn.redhat.com/errata/RHSA-2016-1277.html https://access.redhat.com ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49kONX0.html" rel="bookmark" class="title">课堂作业-寻找水王</a>
					<div>
						[设计思想]   因为水王是整个论坛中发帖和回帖数加起来最多的的人,且超过总帖数的一半以上.(这里将发帖数和回帖数记在一起)使用&quot;两两相消&quot;的方法.将帖子的作者id纳入数组,将数组 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyBzJY0.html" rel="bookmark" class="title">第三章--语句</a>
					<div>
						3.6--语句 if语句 格式:if(condition) { statement_1 } else{ statement_2 },ECMAscript会将condition转换为boolean值,t ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0l15JN3.html" rel="bookmark" class="title">2014-7-30  晴  IIS配置等</a>
					<div>
						在今天之前,我只知道有IIS这个东西,却不知道这是什么,不知道除了发布网站之外还有什么作用.因为我之前有尝试着配置过,所以我以为我了解了一些配置iis的事宜.可是今天的配置却让我着实汗颜了一把,从开头 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pkNVK3.html" rel="bookmark" class="title">那本叫编程珠玑的书中与数学相关的几个问题</a>
					<div>
						...又是一篇装逼水文,先挖坑... 会写一下证明,当然了都是小学生竞赛题...到泰勒级数就封顶了... 1. 连续数组最大和的分治算法的时间复杂度为O(nlogn) 2. 证明72法则,科学炒股.  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3ZQByG0.html" rel="bookmark" class="title">js去除范围内所有标签并显示指定字符串</a>
					<div>
						代码: &lt;div id=&quot;txt&quot;&gt;&lt;/div&gt; &lt;script type=&quot;text/javascript&quot;&gt; funct ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0xek7r3.html" rel="bookmark" class="title">cactiez安装配置</a>
					<div>
						一.下载cactieziso文件 搭建虚拟机安装cactize系统(这一块网上很多) 二.设置CactiEZ监控主机 默认安装好之后,系统登录用户root,密码CactiEZ (区分大小写) 以下操作 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.023 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
